## snek 1.3

=== Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = .

include snek-install.defs

SNEK_OTHEROS?=1
ifeq ($(SNEK_OTHEROS),1)
SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx
endif

SUBDIRS = snekde doc examples $(SNEK_OTHEROS_DIR)

SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)

all: $(SNEKS)
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)); done

$(SNEKS): FORCE
	+cd `dirname $@` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)

FORCE:

check: all
	+cd test && make $@

SHAREFILES = \
	snek.defs \
	$(SNEK_SRC) \
	$(SNEK_EXT_SRC) \
	$(SNEK_RAW_INC) \
	$(SNEK_EXT_INC) \
	$(SNEK_BUILTINS) \
	$(SNEK_EXT_BUILTINS) \
	$(SNEK_ROOT)/snek-gram.ll \
	$(SNEK_ROOT)/snek-builtin.py

IMAGEFILES = \
	snek.svg

DOCFILES = \
	$(IMAGEFILES)

PKGFILES = \
	snek.pc

install: $(SHAREFILES) $(PKGFILES) $(DOCFILES)
	install -d $(DESTDIR)$(SHAREDIR)
	for i in $(SHAREFILES); do install --mode=644 "$$i" $(DESTDIR)$(SHAREDIR) || exit 1; done
	install -d $(DESTDIR)$(PKGCONFIG)
	for i in $(PKGFILES); do install --mode=644 "$$i" $(DESTDIR)$(PKGCONFIG) || exit 1; done
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR) || exit 1; done
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done

upload: $(SNEKS)
	+cd doc && make upload
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done

otheros: $(SNEKS)
	+cd doc && make
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done

snek.pc: snek.pc.in
	$(SNEK_SED) $^ > $@

snek-mu.py:
	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@

docker:
	docker build -t phsilva/snek .

clean:
	rm -f snek.pc
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done

=== doc/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=snek.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css coderay-asciidoctor.css
IMAGE_FILES=../snek.svg

all: $(HTML_FILES) $(PDF_FILES)

BOOK_FILES=snek-book.pdf snek-cover.pdf snek-book-book.pdf snek-cover-book.pdf

book: $(BOOK_FILES)

LETTER_ATTRIBUTES=--attribute='pdf-style=snek' 
BOOK_ATTRIBUTES=--attribute='pdf-style=snek-book' 
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v -B$(SNEK_ROOT) $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf -B$(SNEK_ROOT) $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): snek-theme.yml $(IMAGE_FILES)

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES)

install: $(DOCFILES)
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR) || exit 1; done

snek-book.pdf: snek.adoc snek-book-theme.yml
	asciidoctor-pdf -o `pwd`/$@ -B$(SNEK_ROOT) $(ATTRIBUTES) $(BOOK_ATTRIBUTES) snek.adoc

snek-book-book.pdf: snek-book.pdf
	pdfbook2 -n --paper=letter snek-book.pdf

snek-cover.pdf: snek-cover.svg
	rsvg-convert -d 72 -p 72 -f pdf -o $@ $^

snek-cover-book.pdf: snek-cover.svg
	rsvg-convert -d 69.05 -p 69.94 -f pdf -o $@ $^

upload: $(DOCFILES)
	rsync -avz $(DOCFILES) fonts $(SNEKDOC)

coderay-asciidoctor.css: $(HTML_FILES)

clean::
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES) coderay-asciidoctor.css

=== examples/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = ..

include $(SNEK_ROOT)/snek-install.defs

all:
	echo all done

EXAMPLES = \
	blink.py \
	hanoi.py \
	morse.py \
	snek-bsd.py \
	snek.py \
	track-light.py \
	badshuffle.py \
	goodshuffle.py

install:
	install -d "$(DESTDIR)$(EXAMPLEDIR)"
	for example in $(EXAMPLES); do install -m 0644 "$$example" "$(DESTDIR)$(EXAMPLEDIR)" || exit 1; done

=== test/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=..

include $(SNEK_ROOT)/snek.defs

PYTHON3?=python3
SNEK_NATIVE?=$(SNEK_PORTS)/posix/snek
SNEK_RISCV?=$(SNEK_PORTS)/qemu-riscv/snek-riscv
SNEK_ARM?=$(SNEK_PORTS)/qemu-arm/snek-arm

LANGS=python3 $(SNEK_NATIVE) $(SNEK_ARM)

SUCCESS_TESTS = \
	andor.py \
	list.py \
	dict.py \
	equal_is.py \
	float.py \
	for-array.py \
	for-range.py \
	for-string.py \
	for-break.py \
	for-nested.py \
	global.py \
	if.py \
	int.py \
	math.py \
	op.py \
	range.py \
	slice.py \
	while.py \
	while-break.py \
	while-else.py \
	scoping-global.py \
	scoping-local.py \
	none.py \
	args.py \
	assert-success.py \
	interpolate-list.py

FAIL_TESTS = \
	scoping-no-decl.py \
	list-named.py \
	tuple-named.py \
	range-named.py \
	formal-named-first.py \
	actual-named-first.py \
	args-missing.py \
	arg-dup1.py \
	arg-dup2.py \
	arg-unknown.py \
	assert-fail.py

check:
	@exit=0; \
	for TEST in $(SUCCESS_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			if $$lang $$TEST; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	for TEST in $(FAIL_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			$$lang $$TEST >/dev/null 2>&1; \
			if [ $$? -eq 1 ]; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	exit $$exit

=== hosts/linux/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

LINUX_DIST=snek-linux-$(SNEK_VERSION).tar.bz2
LINUX_SH=snek-linux-$(SNEK_VERSION).sh
DESKTOP_FILES=$(SNEK_PORTS)/posix/snek.desktop.in $(SNEK_ROOT)/snekde/snekde.desktop.in

PROGS= \
	$(SNEK_PORTS)/posix/snek \
	$(SNEK_ROOT)/snekde/snekde \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.in \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.in \
	$(SNEK_PORTS)/mega/snek-mega-install.in

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(SNEK_ROOT)/doc/snek.pdf \
	$(SNEK_ROOT)/snekde/snekde.1 \
	$(SNEK_ROOT)/COPYING \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.1 \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.1 \
	$(SNEK_PORTS)/mega/snek-mega-install.1

LINUX_FILES=$(PROGS) $(DESKTOP_FILES) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(LINUX_SH)

$(LINUX_SH): $(LINUX_DIST) linux-install.sh
	cat linux-install.sh $(LINUX_DIST) > $@
	chmod +x $@

linux-install.sh: linux-install.sh.in
	$(SNEK_SED) $^ > $@

$(LINUX_DIST): $(LINUX_FILES) $(LINUX_EXTRA)
	-rm -f $@
	-rm -rf linux
	mkdir -p linux/Snek
	cp -a $(LINUX_FILES) linux/Snek
	tar cjf $@ -C linux Snek

install:
	echo install done

upload: $(LINUX_SH)
	rsync -avz $(LINUX_SH) $(SNEKDIST)

clean:
	rm -f snek-*.sh *.bz2
	rm -rf linux

=== hosts/windows/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-windows.c \
	$(SNEK_ROOT)/snek-math.c

SNEK_LOCAL_INC = snek-windows.h
SNEK_LOCAL_BUILTINS = snek-windows.builtin $(SNEK_ROOT)/snek-math.builtin

INF=altusmetrum.inf
WINDOWS_FILES=snek.exe snek.ico snekde.py $(SNEK_ROOT)/doc/snek.pdf $(SNEK_ROOT)/examples $(SNEK_ROOT)/COPYING $(FIRMWARE) $(USBFIRMWARE) $(INF)

include $(SNEK_ROOT)/snek-install.defs

WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe

CC=i686-w64-mingw32-gcc
MINGFLAGS=-Wall -Wextra -mconsole

OPT=-O0

CFLAGS=$(OPT) -g -I. $(SNEK_CFLAGS) $(MINGFLAGS)

LIBS=-lm

all: $(WINDOWS_INSTALL)

$(WINDOWS_INSTALL): $(WINDOWS_FILES) snek.cfg
	pynsist snek.cfg

snek.cfg: snek.cfg.in $(SNEK_ROOT)/snek-install.defs $(SNEK_ROOT)/snek.defs
	for i in $(FIRMWARE); do echo "	$$i"; done | sed '/@SNEK_FIRMWARE@/r /dev/stdin' snek.cfg.in | sed '/@SNEK_FIRMWARE/d' | $(SNEK_SED) > $@

snek.exe: $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

vpath %.svg $(SNEK_ROOT)

snekde.py: $(SNEK_ROOT)/snekde/snekde.py
	cp $^ $@

.SUFFIXES: .svg .build .icns .ico .rc .o .exe

.svg.build:
	for i in $(RES); do rsvg-convert -w $$i -h $$i -o $*-$$i.png $^ || exit 1; done && touch $@

.build.ico:
	icotool -c -o $@ $(shell for i in $(RES); do echo $*-$$i.png; done)

.ico.rc:
	./make-rc "$*" $(VERSION) > $@

RES=16 24 32 48 64 72 96 128 180 256

install:
	echo install done

upload: $(WINDOWS_INSTALL)
	rsync -avz $(WINDOWS_INSTALL) $(SNEKDIST)

clean::
	rm -f snek.exe snek.ico snekde.py snek.cfg snek-*.png
	rm -rf build

=== ports/esp32/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

all:
	make -C main all
	./esp32-idf build

clean:
	./esp32-idf clean
	make -C main clean

load:
	./esp32-idf -p /dev/ttyUSB1 flash

connect:
	minicom -D /dev/ttyUSB1 -b 115200

=== ports/mega/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c \
	snek-mega.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-math.builtin \
	snek-input.builtin \
	snek-mega.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

USBSERIAL_HEX=Arduino-usbserial-atmega16u2-Mega2560-Rev3.hex

BASE=snek-mega-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc
CFLAGS=-Os -DF_CPU=16000000UL -mmcu=atmega2560 -I. -I$(SNEK_LOCAL_VPATH) -g -fno-jump-tables $(SNEK_CFLAGS) -mcall-prologues -Waddr-space-convert
LDFLAGS=-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x3e000 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x1e00 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x1000 \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyACM0

all: $(HEX) snek-mega-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-mega-install: snek-mega-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-mega-install
	./snek-mega-install -port $(PORT) -hex $(HEX)

install: snek-mega-install $(HEX) $(USBSERIAL_HEX) snek-mega-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-mega-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(USBSERIAL_HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-mega-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-mega-install

load-direct: $(HEX)
	avrdude -patmega2560 -cwiring -P/dev/ttyACM0 -b115200 -D -Uflash:w:$(HEX):i

=== ports/qemu-riscv/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_QEMU = $(SNEK_ROOT)/chips/qemu

ARCH = riscv64-unknown-elf
ARCH_CFLAGS = -march=rv32imac -mabi=ilp32
PROGNAME = snek-qemu-riscv

include $(SNEK_QEMU)/snek-qemu.defs

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) snek-riscv

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-Tsnek-qemu-riscv.ld -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

snek-riscv: snek-riscv.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install: $(PROG) snek-riscv
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)
	install snek-riscv $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/snekboard/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-board
PRODUCT_NAME=snekboard
IDPRODUCT=0x804D
IDVENDOR=0x239A

BOOTLOADER_BIN=bootloader-snekboard-v3.7.0.bin

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-board.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) $(BIN) $(UF2) snek-board-install

$(PROG): Makefile $(OBJ) $(SNEK_SAMD21)/snek-samd21.ld
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)*.elf $(PROGNAME)*.bin $(PROGNAME)*.uf2 $(PROGNAME)*.map ao-product.h
	rm -f snek-board-install

snek-board-install: snek-board-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

echo:
	echo PROG is $(PROG)

install: $(UF2) $(BOOTLOADER_BIN) snek-board-install snek-board-install.1
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(BOOTLOADER_BIN) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(BINDIR)
	install snek-board-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-board-install.1 $(DESTDIR)$(MANDIR)/man1

uninstall:

=== ports/µduino/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

PROGNAME=snek-µduino
PRODUCT_NAME=snek-µduino

AVR_CLOCK=16000000UL

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	snek-µduino.builtin

include $(SNEK_ROOT)/snek-install.defs

all: $(ELF) $(HEX) snek-uduino-install

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-uduino-install: snek-uduino-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install:: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

install:: snek-uduino-install snek-uduino-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-uduino-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-uduino-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek-uduino-install
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

uninstall::

ISP=avrisp2

load: $(HEX) snek-uduino-install
	./snek-uduino-install -quick -isp $(ISP) -hex $(HEX) load

=== debian/changelog ===
snek (1.3-1) unstable; urgency=medium

  * Upstream release 1.3
  * Ports to ESP32 and µduino
  * Bug fix in string interpolation
  * Code refactoring and other size reductions
  * Test on embedded ARM processor using QEMU

 -- Keith Packard <keithp@keithp.com>  Sun, 15 Dec 2019 23:02:31 -0800

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12), libreadline-dev, avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.2),
 binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.2),
 python3, lola, gawk, asciidoctor, ruby-asciidoctor-pdf, ruby-coderay, qemu-system-arm
Standards-Version: 4.4.1

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes a binary for that target, the
 snek-duino-install tool for installing Snek on Arduino boards, the
 snekde integrated development environment

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export SNEK_OTHEROS=0
export PREFIX=/usr
export CFLAGS_POSIX=$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS)
export V=1

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip -X.elf

override_dh_dwz:
	dh_dwz -X.elf

## snek 1.4

=== Makefile ===
--- 
+++ 
@@ -17,9 +17,9 @@
 
 include snek-install.defs
 
-SNEK_OTHEROS?=1
+SNEK_OTHEROS?=0
 ifeq ($(SNEK_OTHEROS),1)
-SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx
+SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx $(SNEK_HOSTS)/zip
 endif
 
 SUBDIRS = snekde doc examples $(SNEK_OTHEROS_DIR)
@@ -27,7 +27,7 @@
 SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)
 
 all: $(SNEKS)
-	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)); done
+	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)) || exit 1; done
 
 $(SNEKS): FORCE
 	+cd `dirname $@` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)
@@ -36,6 +36,7 @@
 
 check: all
 	+cd test && make $@
+	+black --check --exclude 'fail-syntax-.*\.py' .
 
 SHAREFILES = \
 	snek.defs \

=== test/Makefile ===
--- 
+++ 
@@ -24,45 +24,55 @@
 LANGS=python3 $(SNEK_NATIVE) $(SNEK_ARM)
 
 SUCCESS_TESTS = \
-	andor.py \
-	list.py \
-	dict.py \
-	equal_is.py \
-	float.py \
-	for-array.py \
-	for-range.py \
-	for-string.py \
-	for-break.py \
-	for-nested.py \
-	global.py \
-	if.py \
-	int.py \
-	math.py \
-	op.py \
-	range.py \
-	slice.py \
-	while.py \
-	while-break.py \
-	while-else.py \
-	scoping-global.py \
-	scoping-local.py \
-	none.py \
-	args.py \
-	assert-success.py \
-	interpolate-list.py
+	pass-andor.py \
+	pass-list.py \
+	pass-dict.py \
+	pass-equal_is.py \
+	pass-float.py \
+	pass-for-array.py \
+	pass-for-range.py \
+	pass-for-string.py \
+	pass-for-break.py \
+	pass-for-nested.py \
+	pass-global.py \
+	pass-if.py \
+	pass-int.py \
+	pass-math.py \
+	pass-op.py \
+	pass-range.py \
+	pass-slice.py \
+	pass-while.py \
+	pass-while-break.py \
+	pass-while-else.py \
+	pass-scoping-global.py \
+	pass-scoping-local.py \
+	pass-none.py \
+	pass-args.py \
+	pass-assert-success.py \
+	pass-interpolate-list.py \
+	pass-get.py \
+	pass-interpolate-str.py \
+	pass-trailing-comma.py
+
+SYNTAX_TESTS = \
+	fail-syntax-lex-bang.py \
+	fail-syntax-list-named.py \
+	fail-syntax-tuple-named.py
 
 FAIL_TESTS = \
-	scoping-no-decl.py \
-	list-named.py \
-	tuple-named.py \
-	range-named.py \
-	formal-named-first.py \
-	actual-named-first.py \
-	args-missing.py \
-	arg-dup1.py \
-	arg-dup2.py \
-	arg-unknown.py \
-	assert-fail.py
+	fail-scoping-no-decl.py \
+	fail-range-named.py \
+	fail-formal-named-first.py \
+	fail-actual-named-first.py \
+	fail-args-missing.py \
+	fail-arg-dup1.py \
+	fail-arg-dup2.py \
+	fail-arg-unknown.py \
+	fail-assert-fail.py \
+	fail-interpolate-missing.py \
+	fail-interpolate-extra.py \
+	fail-interpolate-badformat.py \
+	$(SYNTAX_TESTS)
 
 check:
 	@exit=0; \
@@ -73,7 +83,7 @@
 			if $$lang $$TEST; then \
 				echo "    pass $$baselang"; \
 			else \
-				echo "    ***************** $baselang fail *********************"; \
+				echo "    ***************** $$baselang fail *********************"; \
 				exit=1;\
 			fi; \
 		done; \
@@ -86,7 +96,7 @@
 			if [ $$? -eq 1 ]; then \
 				echo "    pass $$baselang"; \
 			else \
-				echo "    ***************** $baselang fail *********************"; \
+				echo "    ***************** $$baselang fail *********************"; \
 				exit=1;\
 			fi; \
 		done; \

=== hosts/macosx/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../..

include $(SNEK_ROOT)/snek-install.defs

MACOSX_RES=16 32 128 256 512
MACOSX_ICON_PNGS = $(shell for i in $(MACOSX_RES); do echo snek-$$i.png; done)
MACOSX_ICON = snek.icns
MACOSX_DIST = snek-mac-$(SNEK_VERSION).dmg

SNEKDE = $(SNEK_ROOT)/snekde/snekde.py
SNEKDE_SCRIPTS = runsnekde snekde-script
SNEKDE_FILES = $(SNEKDE_SCRIPTS) snekde-Info.plist $(SNEKDE)

ifneq ($(strip $(SNEKMAC)),)
SNEK = snek
SNEK_SCRIPTS =  runsnek snek-script
SNEK_FILES = $(SNEK_SCRIPTS) snek-Info.plist $(SNEK)
endif

MACOSX_INSTALL = install-macosx

MACOSX_DOCS = $(PDF) $(SNEK_ROOT)/COPYING ReadMe-Mac.rtf

MACOSX_FILES=$(SNEKDE_FILES) $(SNEK_FILES) serial $(MACOSX_ICON) $(MACOSX_SCRIPTS) $(MACOSX_INSTALL) $(MACOSX_DOCS) $(SNEK_ROOT)/examples/*.py

all: $(MACOSX_DIST)

$(MACOSX_ICON): $(SNEK_ROOT)/snek.svg
	for i in $(MACOSX_RES); do rsvg-convert -w $$i -h $$i -o snek-$$i.png $^; done
	png2icns $@ $(MACOSX_ICON_PNGS)

macosx: $(MACOSX_FILES)
	rm -rf macosx
	mkdir -p macosx/examples

ifeq ($(strip $(SNEKMAC)),)
snek-bits:
	echo 'no snek app'
else
snek-bits: $(SNEK_FILES) macosx
	#
	# snek
	#
	mkdir -p macosx/snek.app/Contents/Resources macosx/snek.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snek.app/Contents/PkgInfo
	cp -p snek-Info.plist macosx/snek.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snek.app/Contents/Resources
	cp -a $(SNEK) macosx/snek.app/Contents/Resources
	cp -p $(SNEK_SCRIPTS) macosx/snek.app/Contents/MacOS/
endif

$(MACOSX_DIST): $(MACOSX_FILES) macosx
	rm -f $@
	cp -a $(MACOSX_DOCS) macosx
	cp -a $(MACOSX_INSTALL) macosx
	cp -a $(FIRMWARE) macosx
	cp -a $(USBFIRMWARE) macosx
	cp -a $(SNEK_ROOT)/examples/* macosx/examples
	#
	# snekde
	#
	mkdir -p macosx/snekde.app/Contents/Resources macosx/snekde.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snekde.app/Contents/PkgInfo
	cp -p snekde-Info.plist macosx/snekde.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snekde.app/Contents/Resources
	cp -a $(SNEKDE) macosx/snekde.app/Contents/Resources
	cp -a serial macosx/snekde.app/Contents/Resources
	cp -p $(SNEKDE_SCRIPTS) macosx/snekde.app/Contents/MacOS/
	#
	# generate iso image
	#
	genisoimage -D -V Snek-$(SNEK_VERSION) -no-pad -r -apple -o $@ macosx

serial: always
	rsync -a --delete --delete-excluded --exclude '__pycache__' --exclude '*.pyc' /usr/lib/python3/dist-packages/serial/ serial

always:

snekde-Info.plist: snekde-Info.plist.in
	$(SNEK_SED) $^ > $@

snek-Info.plist: snek-Info.plist.in
	$(SNEK_SED) $^ > $@

$(SNEK): FORCE
	./build-mac $(SNEKMAC) $@

FORCE:

install:
	echo install done

upload: $(MACOSX_DIST)
	rsync -avz $(MACOSX_DIST) $(SNEKDIST)

clean:
	rm -rf serial
	rm -rf snek
	rm -f $(MACOSX_ICON) $(MACOSX_ICON_PNGS)
	rm -f snekde-Info.plist snek-Info.plist
	rm -rf macosx *.dmg

=== ports/duemilanove/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-duemilanove.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-duemilanove.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-duemilanove-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x7a0 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x400 \
	-Wl,-Map=$(MAP)

ISP = usbtiny
#ISP = avrisp2

#
# lfuse: 0xff
#	CKDIV8:		1	no divide by 8
#	CKOUT:		1	no clock output
#	SUT1:		1	crystal osc, slow startup
#	SUT0:		1	crystal osc, slow startup
#	CKSEL3:		1	low swing osc, 8-16MHz
#	CKSEL2:		1	low swing osc, 8-16MHz
#	CKSEL1:		1	low swing osc, 8-16MHz
#	CKSEL0:		1	crystal osc
# hfuse:
#	RSTDISBL:	1	reset enabled
#	DWEN:		1	debug wire disabled
#	SPIEN:		0	SPI program enabled
#	WDTON:		1	watch dog disabled
#	EESAVE:		0	EEPROM saved across chip erase
#	BOOTSZ1:	1	256 words
#	BOOTSZ0:	1	256 words
#	BOOTRST:	1	boot to address 0
# efuse:
#	BODLEVEL2	1	brown out 2.5-2.9V
#	BODLEVEL1	0	brown out 2.5-2.9V
#	BODLEVEL0	1	brown out 2.5-2.9V

all: $(HEX) snek-duemilanove-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-duemilanove-install: snek-duemilanove-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

set-fuse:
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U lfuse:w:0xff:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U hfuse:w:0xd7:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U efuse:w:0xfd:m

load: $(HEX) snek-duemilanove-install
	./snek-duemilanove-install -isp $(ISP) -hex $(HEX) load

install: snek-duemilanove-install $(HEX) snek-duemilanove-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-duemilanove-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-duemilanove-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf *.hex *.map snek-duemilanove-install

=== ports/esp32/Makefile ===
--- 
+++ 
@@ -12,16 +12,28 @@
 # General Public License for more details.
 #
 
-all:
+include ../../snek.defs
+
+ESP32_IDF ?= ./esp32-idf
+
+TARGET=snek-esp32-$(SNEK_VERSION).bin
+TARGET_DASH=snek-esp32-$(SNEK_VERSION_DASH).bin
+
+all: $(TARGET)
+
+$(TARGET): build/$(TARGET_DASH)
+	cp $^ $@
+
+build/$(TARGET_DASH):
 	make -C main all
-	./esp32-idf build
+	SNEK_VERSION_DASH=$(SNEK_VERSION_DASH) $(ESP32_IDF) build
 
-clean:
-	./esp32-idf clean
-	make -C main clean
+clean::
+	$(ESP32_IDF) clean
+	+make -C main clean
 
 load:
-	./esp32-idf -p /dev/ttyUSB1 flash
+	$(ESP32_IDF) -p /dev/ttyUSB1 flash
 
 connect:
 	minicom -D /dev/ttyUSB1 -b 115200

=== ports/hifive1revb/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

PROGNAME=snek-hifive1revb
PRODUCT_NAME=snek-hifive1revb

# Note -- must set FREEDOM_METAL before building

FREEDOM_METAL ?= /must/set/FREEDOM_METAL

FREEDOM_METAL_PICO = $(FREEDOM_METAL)/pico
FREEDOM_METAL_GLOSS = $(FREEDOM_METAL)/gloss
LD_SCRIPT = metal.default.lds
FREEDOM_METAL_SRC = $(FREEDOM_METAL)/src
FREEDOM_METAL_DRIVERS = $(FREEDOM_METAL_SRC)/drivers
FREEDOM_METAL_INC = $(FREEDOM_METAL)

SNEK_LOCAL_VPATH = $(SNEK_FE310):$(SNEK_AO):$(FREEDOM_METAL_SRC):$(FREEDOM_METAL_DRIVERS):$(FREEDOM_METAL_PICO):$(FREEDOM_METAL_GLOSS)

PICOLIBC_PRINTF_CFLAGS = -DPICOLIBC_FLOAT_PRINTF_SCANF

PICOLIBC_CFLAGS= \
	-specs=picolibc.specs \
	-ffunction-sections \
	-fdata-sections \
	$(PICOLIBC_PRINTF_CFLAGS)

OPT=-Os -g

WARN_FLAGS=-Wall -Wextra -Wcast-align \
	-Wpointer-arith \
	-Wstrict-prototypes \
	-Wmissing-prototypes \
	-Wmissing-declarations \
	-Wnested-externs \
	-Wshadow \
	-Warray-bounds=2\
	-Wno-missing-prototypes\
	-Wno-unused-parameter\
	-Wno-strict-prototypes\
	-Wno-missing-declarations\
	-Wno-cast-align\
	-Wno-maybe-uninitialized

AO_CFLAGS=\
	-std=gnu99 $(WARN_FLAGS) $(OPT) -g

HIFIVE1REVB_CFLAGS=-march=rv32imac -mabi=ilp32 \
	-I. -I$(SNEK_ROOT) -I$(FREEDOM_METAL_INC) $(PICOLIBC_CFLAGS)

CFLAGS = $(HIFIVE1REVB_CFLAGS) $(SNEK_CFLAGS) $(AO_CFLAGS)

LDFLAGS=$(CFLAGS) -n -Wl,--gc-sections

LIBS=-lm

ARCH=riscv64-unknown-elf
CC=$(ARCH)-gcc
OBJCOPY=$(ARCH)-objcopy

PROG=$(PROGNAME)-$(SNEK_VERSION).elf
HEX=$(PROGNAME)-$(SNEK_VERSION).hex
MAP=$(PROGNAME)-$(SNEK_VERSION).map

.SUFFIXES: .elf .bin

.elf.bin:
	$(OBJCOPY) -O binary -S $^ $@

SNEK_LOCAL_SRC = \
	vector.S \
	entry.S \
	init.c \
	inline.c \
	fixed-clock.c \
	riscv_plic0.c \
	riscv_clint0.c \
	riscv_cpu.c \
	sifive_fe310-g000_prci.c \
	sifive_fe310-g000_hfrosc.c \
	sifive_fe310-g000_hfxosc.c \
	sifive_fe310-g000_lfrosc.c \
	sifive_fe310-g000_pll.c \
	sifive_uart0.c \
	sifive_spi0.c \
	sifive_gpio-leds.c \
	sifive_wdog0.c \
	sifive_rtc0.c \
	sifive_gpio0.c \
	sifive_i2c0.c \
	i2c.c \
	sifive_local-external-interrupts0.c \
	sys_exit.c \
	button.c \
	cache.c \
	clock.c \
	cpu.c \
	gpio.c \
	interrupt.c \
	led.c \
	lock.c \
	memory.c \
	pmp.c \
	privilege.c \
	rtc.c \
	shutdown.c \
	spi.c \
	switch.c \
	synchronize_harts.c \
	time.c \
	timer.c \
	trap.S \
	uart.c \
	watchdog.c \
	snek-metal.c \
	snek-math.c \
	snek-io.c \
	snek-input.c \
	snek-metal-gpio.c \
	snek-metal-uart.c \
	snek-metal-builtin.c

SNEK_LOCAL_INC = \
	$(SNEK_FE310_INC)

SNEK_LOCAL_BUILTINS = \
	snek-math.builtin \
	snek-gpio.builtin \
	snek-input.builtin \
	snek-hifive1revb.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(patsubst %.S,%.o,$(patsubst %.c,%.o,$(SRC)))

echo::
	echo $(OBJ)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -T$(LD_SCRIPT) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(HEX): $(PROG)
	$(OBJCOPY) -O ihex -S $^ $@

$(OBJ): $(SNEK_INC) $(FREEDOM_METAL)

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)*.elf $(PROGNAME)*.hex $(PROGNAME)*.map ao-product.h
	rm -f snek-board-install

snek-board-install: snek-board-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

echo::
	echo PROG is $(PROG)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)

uninstall:

$(FREEDOM_METAL):
	if [ ! -d $@ ]; then \
		echo "Need to set FREEDOM_METAL before building snek-hifive1revb";\
		exit 1;\
	fi

=== ports/mega/Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 
 $(ELF): $(SNEK_OBJ)
 	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
-	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)
+	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)
 
 snek-mega-install: snek-mega-install.in
 	$(SNEK_SED) $^ > $@

=== debian/changelog ===
snek (1.4-3) unstable; urgency=medium

  * Skip building firmware in binary-arch target

 -- Keith Packard <keithp@keithp.com>  Fri, 22 May 2020 02:42:30 -0700

snek (1.4-2) unstable; urgency=medium

  * Prepare source upload Closes: #951306.

 -- Keith Packard <keithp@keithp.com>  Thu, 21 May 2020 15:55:29 -0700

snek (1.4-1) unstable; urgency=medium

  * Upstream release 1.4
  * Ports to EV3 and HiFive1 Rev B
  * Lessons with Snekboard and LEGO added
  * Make autopkgtest use installed snek binaries

 -- Keith Packard <keithp@keithp.com>  Wed, 13 May 2020 13:46:01 -0700

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), libreadline-dev, avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4),
 binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
 python3, lola, gawk, asciidoctor, ruby-asciidoctor-pdf, ruby-coderay, qemu-system-arm,
 gcc-arm-linux-gnueabi, libc6-dev-armel-cross, black
Standards-Version: 4.5.0

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes binaries and installation tools for many
 targets along with the snekde integrated development environment.

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,19 @@
 	dh $@
 
 override_dh_strip:
-	dh_strip -X.elf
+	dh_strip -X.elf -Xsnek-ev3
 
 override_dh_dwz:
-	dh_dwz -X.elf
+	dh_dwz -X.elf -Xsnek-ev3
+
+override_dh_shlibdeps:
+	dh_shlibdeps -X.elf -Xsnek-ev3
+
+override_dh_auto_build-arch:
+	dh_auto_build -- FIRMWARE=
+
+override_dh_auto_test-arch:
+	dh_auto_test -- FIRMWARE= SNEK_RISCV= SNEK_ARM=
+
+override_dh_auto_install-arch:
+	dh_auto_install -- FIRMWARE=

=== debian/tests/control ===
Test-Command: make SNEK_NATIVE=/usr/bin/snek SNEK_ARM=/usr/share/snek/snek-arm SNEK_RISCV=/usr/share/snek/snek-riscv -C test check
Depends: @, qemu-system-arm, qemu-system-misc
